﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Controls.Charts;

namespace SL_xamPieChart
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            LayoutRoot.Loaded += new RoutedEventHandler(LayoutRoot_Loaded);           
        }

        void LayoutRoot_Loaded(object sender, RoutedEventArgs e)
        {           
            Legend.LegendItemMouseLeftButtonDown+=new DataChartLegendMouseButtonEventHandler(Legend_LegendItemMouseLeftButtonDown);
        }

        void  Legend_LegendItemMouseLeftButtonDown(object sender, DataChartLegendMouseButtonEventArgs e)
        {
            DataItem item = e.Item as DataItem;
            int indx = ((ObservableCollection<DataItem>)pieChart.ItemsSource).IndexOf(item);

            if (pieChart.SelectedSlices.IndexOf(indx) == -1)
            {
                pieChart.SelectedSlices.Add(indx);
            }
            else
                pieChart.SelectedSlices.Remove(indx);

            if (pieChart.ExplodedSlices.IndexOf(indx) == -1)
            {
                pieChart.ExplodedSlices.Add(indx);
            }
            else
                pieChart.ExplodedSlices.Remove(indx);

            setTextBlock_SelectedSlices();
                
        }        

        private void pieChart_SliceClick(object sender, Infragistics.Controls.Charts.SliceClickEventArgs e)
        {
            e.IsExploded = !e.IsExploded;
            e.IsSelected = !e.IsSelected;

            setTextBlock_SelectedSlices(); 
        }

        private void setTextBlock_SelectedSlices()
        {
            txtblock.Text = "Selected Slices:" + Environment.NewLine;
            foreach (int index in pieChart.SelectedSlices)
            {
                string label = ((ObservableCollection<DataItem>)pieChart.ItemsSource)[index].Label;
                txtblock.Text += label + Environment.NewLine;
            }

        }    

       
    }

    public class DataItem
    {
        public string Label { get; set; }
        public double Value { get; set; }
    }

    public class Data : ObservableCollection<DataItem>
    {
        public Data()
        {
            Add(new DataItem { Label = "Item 1", Value = 15000 });
            Add(new DataItem { Label = "Item 2", Value = 10000 });
            Add(new DataItem { Label = "Item 3", Value = 1200 });
            Add(new DataItem { Label = "Item 4", Value = 70 });
            Add(new DataItem { Label = "Item 5", Value = 50 });
            Add(new DataItem { Label = "Item 6", Value = 2 });
        }
    }

}
